/*! For license information please see plan-repository.js.LICENSE.txt */
"use strict";import FuzzyMatcher from"./fuzzy-matcher.js";import ENV from"../env.js";import Log from"../lib/log.js";import T from"../lib/tool.js";import Config from"../lib/config.js";import Storage from"../lib/storage.js";async function get(t){return{globalPlan:await getGlobalPlan(),pagePlan:await getPagePlan(t),defaultTagStatus:await getDefaultTagStatus()}}async function getDefaultTagStatus(){return await Storage.get("assistant.default-tag-status","")}async function getPagePlan(t){const a=a=>T.any(T.toArray(a.pattern),(a=>FuzzyMatcher.matchUrl(t,a)))&&!T.any(T.toArray(a.excludePattern),(a=>FuzzyMatcher.matchUrl(t,a))),e=await getCachedPlans(),n=e.find(a);if(n)return n;const s=(await getCustomPlans()).find(a);if(s)return e.unshift(s),await setCachedPlans(e),s;const o=await getPublicPlanPointers();for(let t=0;t<o.length;t++){const n=o[t],s=(await Storage.get(n,[])).find(a);if(s)return e.unshift(s),await setCachedPlans(e),s}return null}const DEFAULT_GLOBAL_PLAN={name:"the global plan",disabled:!0};async function getGlobalPlan(){return await Storage.get("assistant.global-plan",DEFAULT_GLOBAL_PLAN)}async function getCachedPlans(){return Storage.session.get("assistant.cachedPlans",[])}async function setCachedPlans(t){return Storage.session.set("assistant.cachedPlans",t)}async function resetCachedPlans(){return setCachedPlans([])}async function getCustomPlans(){return Storage.get("assistant.custom-plans",[])}async function getPublicPlanPointers(){return Storage.local.get("assistant.public-plan.pointers",[])}async function setPublicPlanPointers(t){return Storage.local.set("assistant.public-plan.pointers",t)}async function getPublicPlanSubscriptions(){return Storage.local.get("assistant.public-plan.subscriptions",[])}async function setPublicPlanSubscriptions(t){return Storage.set("assistant.public-plan.subscriptions",t)}async function updatePublicPlans(t){await resetCachedPlans();const a=T.currentTime(),e=[],n="assistant.public-plan",s=[],o=[],i=await getPublicPlanSubscriptions(),r=await getPublicPlanPointers();for(let l=0;l<t.length;l++)try{const i=new URL(t[l]);i.searchParams.append("t",a.str.intSec),Log.debug(i.toString());const u=await Global.Fetcher.get(i.toString(),{}),c=JSON.parse(u),g=[n,c.name,"latest"].join(".");let p=await Storage.get(g),P="20180101";if(p&&(P=p.split(".").pop()),c.latestVersion>P){Log.debug(`Start update ${c.name} from ${P} to ${c.latestVersion}`);const t=await Global.Fetcher.get(c.updateUrl,{}),a=JSON.parse(t),i=[n,c.name,P].join("."),l=[n,c.name,c.latestVersion].join("."),u=[n,c.name,"text"].join("."),p=r.indexOf(i)>-1;await Storage.set(l,a),await Storage.set(g,l),p&&await Storage.remove(i),await Storage.set(u,t),e.push(l),o.push({ok:!0,subscription:c,updated:!0}),s.push(c)}else e.push(p),o.push({ok:!0,subscription:c,upToDate:!0}),s.push(c),Log.debug("Public plans up to date","name: ",c.name,"version: ",c.latestVersion)}catch(a){o.push({ok:!1,message:a.message});const r=i.find((a=>a.url===t[l]));if(r){const t=[n,r.name,r.latestVersion].join(".");e.push(t),s.push(r)}Log.error(a)}for(let t=0;t<r.length;t++){const a=r[t];if(-1==e.indexOf(a)){const t=T.deleteLastPart(a),e=[t,"latest"].join("."),n=[t,"text"].join(".");await Storage.remove([e,a,n]),Log.debug("delete",e,a,n)}}return await setPublicPlanPointers(e),await setPublicPlanSubscriptions(s),o}async function updateGlobalPlan(t){try{const a=JSON.parse(t);if(a.constructor!==Object)throw new Error(`The global plan must be an Object, but we've got ${a.constructor.name}`);return await Storage.set("assistant.global-plan",a),await Storage.set("assistant.global-plan.text",t),{ok:!0}}catch(t){return{ok:!1,message:t.message}}}async function updateCustomPlans(t){await resetCachedPlans();try{const a=JSON.parse(t);return await Storage.set("assistant.custom-plans",a),await Storage.set("assistant.custom-plan.text",t),{ok:!0}}catch(t){return{ok:!1,message:t.message}}}let Global=null;function init(t){Global=t,Config.load().then((t=>{t.autoUpdatePublicPlan&&Storage.get("assistant.public-plan.subscription-urls",[]).then(updatePublicPlans)}))}function restart(){resetCachedPlans()}const PlanRepository={init,restart,get,updatePublicPlans,updateCustomPlans,updateGlobalPlan};export default PlanRepository;