import Log from"./lib/log.js";import ENV from"./env.js";import T from"./lib/tool.js";import ExtApi from"./lib/ext-api.js";import ExtMsg from"./lib/ext-msg.js";import MxWcIcon from"./lib/icon.js";import MxWcStorage from"./lib/storage.js";import MxWcConfig from"./lib/config.js";import MxWcLink from"./lib/link.js";import MxWcHandler from"./lib/handler.js";import MxEvTarget from"./lib/event-target.js";import Fetcher from"./lib/fetcher.js";import TaskFetcher from"./lib/task-fetcher.js";import initBackend_Clipping from"./clipping/backend.js";import initBackend_Saving from"./saving/backend.js";import initBackend_Assistant from"./assistant/backend.js";import initBackend_Selection from"./selection/backend.js";import Handler_Browser from"./handler/browser.js";import Handler_NativeApp from"./handler/native-app.js";import Handler_WizNotePlus from"./handler/wiznoteplus.js";import BlobUrl from"./background/blob-url.js";import MxWcMigration from"./background/migration.js";import ContentScriptsLoader from"./content-scripts-loader.js";const Global={evTarget:new MxEvTarget};function messageHandler(e,t){return new Promise((function(n,a){switch(Log.debug(e.type),e.type){case"get.frame-id":n(t.frameId);break;case"close.off-screen":Log.debug("close off-screen document"),ExtApi.closeOffscreenDoc().then(n);break;case"show.badge":const o=e.body||{};MxWcIcon.showTabBadge(t.tab.id,o),n();break;case"hide.badge":MxWcIcon.hideTabBadge(t.tab.id),n();break;case"popup-menu.clip-command":loadContentScriptsAndSendMsg(getClipCommandMsg(e.body.command),t.tab).then(n,a);break;case"handler.get-info":getHandlerByName(e.body.name).getInfo().then(n,a);break;case"handler.native-app.disconnect":Handler_NativeApp.disconnect(n);break;case"handler.native-app.getDownloadFolder":Handler_NativeApp.getDownloadFolder(n);break;case"test.downloadRequest":testDownloadRequest(n,a);break;case"init.downloadFolder":initDownloadFolder(),n();break;case"save.category":saveCategory(e.body),n();break;case"save.tags":saveTags(e.body),n();break;case"save.last-tags":resetStates("last-tags",e.body),n();break;case"save.clippingHistory":saveClippingHistory(e.body),n();break;case"reset.clips":resetStates("clips",e.body),n();break;case"reset.categories":resetStates("categories",e.body),n();break;case"reset.tags":resetStates("tags",e.body),n();break;case"export.history":exportHistory(e.body.content).then(n);break;case"clipping.delete":deleteClipping(e.body,n);break;case"history.refresh":refreshHistory(n);break;case"generate.clipping.js":generateClippingJs(n);break;case"generate.clipping.js.if-need":generateClippingJsIfNeed(),n();break;case"create-tab":ExtApi.createTab(e.body.link).then(n);break;case"asset-cache.peek":n([]);break;case"asset-cache.reset":n();break;case"backup-to-file":backupToFile().then(n);break;case"migrate-config":migrateConfig(e.body).then(n,a);break;case"config.changed":configChanged(e.body),n();break;default:a(new Error(`background.js: Unknown message: ${e.type}`))}}))}function executeCommand(e){const{exec:t,args:n=[]}=e,a=CommandFnDict[t];a?(a(...n),Log.debug("execute: ",e)):Log.debug("Couldn't find function to execute, name: ",t)}function getBuiltinCommand(e){switch(e){case"_doNothing":return{exec:"doNothing"};case"_clipAsDefault":return{exec:"startClip",args:[{badge:{text:null}}]};case"_clipAsHTML":return{exec:"startClip",args:[{badge:{text:"H"},config:{saveFormat:"html"}}]};case"_clipAsMarkdown":return{exec:"startClip",args:[{badge:{text:"M"},config:{saveFormat:"md"}}]};case"_openLastClipping":return{exec:"openLastClippingResult"}}return null}function getUserCommand(e,t){let n={};try{n=JSON.parse(t.userCommandsText||"{}")}catch(e){Log.error("Invalid JSON(userCommandsText): ",t.userCommandsText)}return(n||{})[e]}function getClipCommandMsg(e){let t={};switch(e){case"clip-as-default":case"_clipAsDefault":default:t={badge:{text:null}};break;case"clip-as-html":case"_clipAsHTML":t={badge:{text:"H"},config:{saveFormat:"html"}};break;case"clip-as-md":case"_clipAsMarkdown":t={badge:{text:"M"},config:{saveFormat:"md"}}}return{type:"clip-command",body:[t]}}function configChanged({key:e,value:t}){"autoRunContentScripts"===e&&resetAutoRunContentScriptsListener(t)}function deleteClipping(e,t){Handler_NativeApp.deleteClipping(e,(e=>{e.ok&&Global.evTarget.dispatchEvent({type:"clipping.deleted"}),t(e)}))}function refreshHistoryIfNeed(){MxWcConfig.load().then((e=>{e.autoRefreshHistory&&refreshHistory((e=>{e.ok?Log.debug("History refreshed"):(Log.error("AutoRefreshHistory: "),Log.error(e.message))}))}))}function refreshHistory(e){isHandlerReady("refreshHistoryHandler").then((t=>{const{ok:n,message:a,handler:o,config:i}=t;n?(MxWcStorage.get("downloadFolder").then((e=>{e||o.initDownloadFolder(i)})),o.refreshHistory({root_folder:i.rootFolder,time:T.currentTime().toString()},(t=>{if(t.ok){resetStates("clips",t.clippings),resetStates("tags",t.tags),resetStates("categories",t.categories);const n=T.currentTime().toString();MxWcStorage.set("lastRefreshHistoryTime",n),Global.evTarget.dispatchEvent({type:"history.refreshed"}),e({ok:!0,time:t.time})}else e(t)}))):e({ok:!1,message:a})}))}async function exportHistory(e){const t=T.currentTime().str,n={text:e,filename:["mx-wc-history",[t.year,t.month,t.day,t.hour,t.minute,t.second].join(""),"json"].join("."),mimeType:"application/json"};return Handler_Browser.saveTextFile(n)}async function downloadBlobUrl(e){return new Download(ExtApi.downloads,e).download()}function generateClippingJsIfNeed(){MxWcConfig.load().then((e=>{e.autogenerateClippingJs&&generateClippingJs()}))}function generateClippingJs(e){isHandlerReady("offlinePageHandler").then((t=>{const{ok:n,message:a,handler:o,config:i}=t;if(n){let t=MxWcConfig.getDefault().clippingJsPath;0===i.clippingJsPath.indexOf("$STORAGE-PATH/")&&i.clippingJsPath.endsWith("js")&&(t=i.clippingJsPath);const n=t.replace("$STORAGE-PATH",i.rootFolder);MxWcStorage.get("clips",[]).then((t=>{t.forEach((e=>{delete e.paths}));const a={text:`;var clippings = ${JSON.stringify(t)};`,mimeType:"text/javascript",filename:n};o.saveTextFile(a);const i=T.currentTime().toString();MxWcStorage.set("lastGenerateClippingJsTime",i),e&&e({ok:!0,time:i})}))}else e&&e({ok:!1,message:a})}))}function testDownloadRequest(e,t){MxWcConfig.load().then((n=>{Handler_Browser.testDownloadRequest(n,e,t)}))}function initDownloadFolder(){MxWcStorage.get("downloadFolder").then((e=>{e||getClippingHandler(((e,t)=>{e.initDownloadFolder(t)}))}))}function getClippingHandler(e){MxWcConfig.load().then((t=>{e(getHandlerByName(t.clippingHandler),t)}))}function resetStates(e,t){MxWcStorage.set(e,t)}function saveClippingHistory(e){const t=e.clippingHistory;MxWcStorage.get("clips",[]).then((e=>{e.unshift(t),MxWcStorage.set("clips",e)}))}function saveTags(e){const t=e.tags;MxWcStorage.get("tags",[]).then((e=>{T.each(t,(function(t){e=T.remove(e,t)})),T.each(t,(function(t){e.unshift(t)})),MxWcStorage.set("tags",e)}))}function saveCategory(e){const t=e.category;MxWcStorage.get("categories",[]).then((e=>{(e=T.remove(e,t)).unshift(t),MxWcStorage.set("categories",e)}))}function setIconTitle(){const e=["MaoXian Web Clipper",`v${ENV.version}`].join(" ");MxWcIcon.setTitle(e)}function welcomeNewUser(){MxWcStorage.get("firstRunning",!0).then((e=>{e&&(MxWcStorage.set("firstRunning",!1),ExtApi.createTab(MxWcLink.get("extPage.welcome")))}))}async function commandListener(e){Log.debug("shortcutSlot: ",e);const t=e.match(/^slot-(\d+)$/);if(t){const n=await MxWcConfig.load(),a=n["shortcutSlot"+t[1]];if(a){const e=getBuiltinCommand(a)||getUserCommand(a,n);e?executeCommand(e):Log.debug("Couldn't find command with name: ",a)}else Log.debug("Not command is configured with this slot",e)}else Log.debug("Please use one starts with 'slog-' instead, Deprecated: ",e)}async function loadContentScriptsAndSendMsg(e,t){const n=t||await ExtApi.getCurrentTab();if(!n){const t="We can't get the current tab, don't known where to load content scripts, aborted!";throw Log.error(t),Log.error(e),new Error(t)}await storeContentMessage(e);const{loadedFrameIds:a,errorDetails:o}=await ContentScriptsLoader.loadInTab(n.id);if(o.length>0){const e=ContentScriptsLoader.errorDetails2Str(o,n);if(Log.error(e),0==o[o.length-1].frameId)throw await removeContentMessage(),new Error(e)}return a.indexOf(0)>-1||(await removeContentMessage(),Log.debug("send content message to the top frame"),ExtMsg.sendToContent(e))}function storeContentMessage(e){return MxWcStorage.set("content-message",e)}function removeContentMessage(){return MxWcStorage.remove("content-message")}function doNothing(){}function startClip(...e){loadContentScriptsAndSendMsg({type:"clip-command",body:e}).then((()=>{}),(e=>console.error(e)))}async function openLastClippingResult(){const e=await MxWcStorage.get("lastClippingResult");if(!e)return;const{url:t,failedTaskNum:n}=e,a=MxWcLink.get("extPage.last-clipping-result");if(n>0||!t.endsWith(".md")&&!t.endsWith(".html"))return void ExtApi.createTab(a);const o=await MxWcConfig.load(),i=await ExtApi.isAllowedFileSchemeAccess()||o.allowFileSchemeAccess;t.startsWith("http")||i?(MxWcStorage.set("lastClippingResult",null),ExtApi.createTab(t)):ExtApi.createTab(a)}const CommandFnDict={doNothing,startClip,openLastClippingResult};async function backupToFile(){const e=await MxWcConfig.load(),t=[];t.push(T.attributeFilter("config",e.backupSettingPageConfig)),t.push(T.prefixFilter("history.page.cache",e.backupHistoryPageConfig)),t.push(T.prefixFilter("assistant",e.backupAssistantData)),t.push(T.prefixFilter("selectionStore",e.backupSelectionData));const n=await MxWcStorage.query(...t),a=T.currentTime(),o=a.str,i=[o.hour,o.minute,o.second].join("."),r={data:n,backupAt:a.toString()},s={text:T.toJson(r),mimeType:"application/json",filename:`mx-wc-backup_${a.date()}_${i}.json`,saveAs:!0};Handler_Browser.saveTextFile(s)}async function migrateConfig(e){const{ok:t,errMsg:n}=MxWcConfig.isMigratable(e);if(t){const t=await MxWcConfig.load();return MxWcMigration.migrateConfig(e,t)}throw new Error(n)}function resetAutoRunContentScriptsListener(e){Log.debug("Auto run content scripts: ",e),e?bindAutoRunContentScriptsListener():unbindAutoRunContentScriptsListener()}function bindAutoRunContentScriptsListener(){ExtApi.bindPageDomContentLoadListener(pageDomContentLoadedListener,{url:[{schemes:["https","http"]}]})}function unbindAutoRunContentScriptsListener(){ExtApi.unbindPageDomContentLoadedListener(pageDomContentLoadedListener)}async function pageDomContentLoadedListener({url:e,tabId:t,frameId:n}){(await MxWcConfig.load()).autoRunContentScripts&&ContentScriptsLoader.loadInFrame(t,n,!0).catch((e=>{Log.warn(e)}))}async function isHandlerReady(e){const{ok:t,name:n,message:a,config:o}=await MxWcHandler.isReadyByConfig(e,{getHandlerInfoFn:async function(e){const t=getHandlerByName(e);return await t.getInfo()}});return{ok:t,handler:getHandlerByName(n),message:a,config:o}}function getHandlerByName(e){switch(e){case"Browser":default:return Handler_Browser;case"NativeApp":return Handler_NativeApp;case"WizNotePlus":return Handler_WizNotePlus}}async function updateNativeAppConfig(){"NativeApp"===(await MxWcConfig.load()).clippingHandler&&Handler_NativeApp.initDownloadFolder()}function initListeners(){Global.evTarget.addEventListener("saving.completed",generateClippingJsIfNeed),Global.evTarget.addEventListener("history.refreshed",generateClippingJsIfNeed),Global.evTarget.addEventListener("clipping.deleted",generateClippingJsIfNeed)}function generateFrameMsgToken(){const e=["",Date.now(),Math.round(1e4*Math.random())].join("");MxWcStorage.set("frame-msg-token",e)}function onInstalled(e){Log.debug("installed reason: ",e.reason),ExtApi.setUninstallURL(MxWcLink.get("uninstalled")),MxWcMigration.perform()}function init(){Log.debug("background init..."),ExtApi.bindOnInstalledListener(onInstalled),initListeners(),updateNativeAppConfig(),generateFrameMsgToken();const e=MxWcLink.isChrome();MxWcLink.isFirefox(),TaskFetcher.init({Fetcher}),Handler_Browser.init(Object.assign({TaskFetcher},{isChrome:e})),Handler_NativeApp.init({TaskFetcher}),Handler_WizNotePlus.init({TaskFetcher}),ExtMsg.listenBackend("background",messageHandler),refreshHistoryIfNeed(),initBackend_Assistant({Fetcher}),initBackend_Selection(),initBackend_Clipping({Fetcher}),initBackend_Saving(Object.assign({Handler_Browser,Handler_NativeApp,Handler_WizNotePlus},{evTarget:Global.evTarget})),ExtApi.bindOnCommandListener(commandListener),bindAutoRunContentScriptsListener(),setIconTitle(),welcomeNewUser(),Log.debug("background init finish...")}init();