"use strict";import ENV from"../env.js";import T from"../lib/tool.js";import Log from"../lib/log.js";import ExtApi from"../lib/ext-api.js";import MxWcStorage from"../lib/storage.js";import SavingTool from"../saving/new-saving-tool.js";import{NativeAppClient,NativeMessage,DownloadMessage,RefreshHistoryMessage}from"../saving/native-app-message.js";const typesToCache=[],Client=new NativeAppClient(ExtApi.runtime,typesToCache);function disconnect(e){Client.disconnect(e)}function getVersion(e){getVersionAsync().then(e,(n=>{e({ok:!1,message:n.message})}))}async function getVersionAsync(){const e=await new NativeMessage(Client,{type:"get.version"}).send();return{ok:!0,version:e.version,rubyVersion:e.rubyVersion}}function initDownloadFolder(e){getDownloadFolder((e=>{e.ok&&updateDownloadFolder(e.downloadFolder)}))}function getDownloadFolder(e){new NativeMessage(Client,{type:"get.downloadFolder"}).send().then((n=>{e({ok:!0,downloadFolder:T.sanitizePath(n.downloadFolder)})}),(n=>{e({ok:!1,message:n.message})}))}function saveTextFile(e){e.type="download.text",new DownloadMessage(Client,e).send()}function saveClipping(e,n){getVersion((t=>{let a=SavingTool.SaveClipping.MODE.COMPLETE_WHEN_MAIN_TASK_FINISHED;t.ok&&T.isVersionGteq(t.version,"0.2.0")&&(a=SavingTool.SaveClipping.MODE.COMPLETE_WHEN_ALL_TASK_FINISHED);const i=new SavingTool.SaveClipping(e,n,{mode:a});e.tasks.forEach((e=>{saveTask(e).then((({filename:n})=>{i.taskCompleted(e,{fullFilename:n})}),(n=>{i.taskFailed(e,n.message)})).catch((e=>{console.error(e)}))}))}))}function retryTask(e,n){const t=new SavingTool.RetryTask(e,n);t.started(),saveTask(e).then((({filename:e})=>{t.completed()}),(e=>{t.failed(e.message)}))}async function saveTask(e){const n=await getVersionAsync();let t=null;if("url"===e.type&&T.isVersionGteq(n.version,"0.2.4")){const n=await fetchUrlTask(e),a=await T.blob2BinaryString(n),i=Object.assign({},e,{type:"download.url",encode:"base64",content:btoa(a)});t=await new DownloadMessage(Client,i).send()}else{const n=Object.assign({},e,{type:["download",e.type].join(".")});t=await new DownloadMessage(Client,n).send()}const a=T.sanitizePath(t.filename);if(t.failed)throw new Error(t.errMsg);return"mainFileTask"==e.taskType&&updateDownloadFolder(T.sanitizePath(a).replace(e.filename,"")),{filename:a}}async function fetchUrlTask(e){return await Global.TaskFetcher.get(e)}function deleteClipping(e,n){try{e.type="clipping.op.delete",new NativeMessage(Client,e).send().then((e=>{n(e)}),(e=>{n({ok:!1,message:e.message})}))}catch(e){n({ok:!1,message:e.message})}}function refreshHistory(e,n){getVersion((t=>{let a="history.refresh";t.ok&&T.isVersionGteq(t.version,"0.2.6")&&(a="history.refresh_v2"),e.type=a,new RefreshHistoryMessage(Client,e).send().then((e=>{n(e)}),(e=>{n({ok:!1,message:e.message})}))}))}function updateDownloadFolder(e){MxWcStorage.set("downloadFolder",e)}function handleClippingResult(e){return e.url=T.toFileUrl(e.filename),e}function translate(e){return{en:{"g.error.handler.native-app.version":"Extension require the version of Native Application bigger than or equal to $requiredVersion, But current version is $currentVersion, please <a href='go.page:native-app#upgrade' target='_blank'>upgrade your native application</a>","g.error.handler.native-app.install":"It seems like you haven't installed it correctly. (<a href='go.page:native-app' target='_blank'>How to install it</a>)"},"zh-CN":{"g.error.handler.native-app.version":"当前扩展依赖的「本地程序」的版本必须大于或等于 $requiredVersion, 但是当前安装的版本为 $currentVersion，请<a href='go-page:native-app#upgrade' target='_blank'>更新你的本地程序</a>","g.error.handler.native-app.install":"可能是由于你的「本地程序」还没有安装或者安装未成功导致的 (<a href='go.page:native-app' target='_blank'>查看如何安装</a>)"}}[ExtApi.getLocale()](e)}async function getInfo(e){const n=await getVersionAsync();let t=!1,a="";return n.ok?T.isVersionGteq(n.version,ENV.minNativeAppVersion)?t=!0:a=translate("g.error.handler.native-app.version").replace("$requiredVersion",ENV.minNativeAppVersion).replace("$currentVersion",n.version):a=[n.message,translate("g.error.handler.native-app.install")].join("<br />"),{ready:t,message:a,version:n.version,rubyVersion:n.rubyVersion,supportFormats:["html","md"]}}let Global=null;function init(e){Global=e}const ClippingHandler_NativeApp=Object.assign({name:"NativeApp"},{init,saveClipping,saveTextFile,retryTask,handleClippingResult,getDownloadFolder,initDownloadFolder,disconnect,getInfo,getVersion,deleteClipping,refreshHistory});export default ClippingHandler_NativeApp;